import React, { useRef } from 'react';
import { useAsync, useMount } from '@react-devui/hooks';
export function DAlertPopover(props) {
    var _a, _b;
    const { children, dDuration, dEscClosable = true, onClose } = props;
    const dataRef = useRef({});
    const asyncCapture = useAsync();
    useMount(() => {
        if (dDuration > 0) {
            dataRef.current.clearTid = asyncCapture.setTimeout(() => {
                onClose === null || onClose === void 0 ? void 0 : onClose();
            }, dDuration * 1000);
        }
    });
    return React.cloneElement(children, Object.assign(Object.assign({}, children.props), { tabIndex: (_a = children.props.tabIndex) !== null && _a !== void 0 ? _a : -1, role: (_b = children.props.role) !== null && _b !== void 0 ? _b : 'alert', onMouseEnter: (e) => {
            var _a, _b, _c, _d;
            (_b = (_a = children.props).onMouseEnter) === null || _b === void 0 ? void 0 : _b.call(_a, e);
            (_d = (_c = dataRef.current).clearTid) === null || _d === void 0 ? void 0 : _d.call(_c);
        }, onMouseLeave: (e) => {
            var _a, _b;
            (_b = (_a = children.props).onMouseLeave) === null || _b === void 0 ? void 0 : _b.call(_a, e);
            if (dDuration > 0) {
                dataRef.current.clearTid = asyncCapture.setTimeout(() => {
                    onClose === null || onClose === void 0 ? void 0 : onClose();
                }, dDuration * 1000);
            }
        }, onKeyDown: (e) => {
            var _a, _b, _c, _d;
            (_b = (_a = children.props).onKeyDown) === null || _b === void 0 ? void 0 : _b.call(_a, e);
            if (dEscClosable && e.code === 'Escape') {
                (_d = (_c = dataRef.current).clearTid) === null || _d === void 0 ? void 0 : _d.call(_c);
                onClose === null || onClose === void 0 ? void 0 : onClose();
            }
        } }));
}
//# sourceMappingURL=AlertPopover.js.map