/// <reference types="react" />
import type { DId } from '../../utils';
import type { DFormControl } from '../form';
export interface DCheckboxList<V extends DId> {
    label: React.ReactNode;
    value: V;
    disabled?: boolean;
}
export interface DCheckboxGroupProps<V extends DId> extends Omit<React.HTMLAttributes<HTMLDivElement>, 'children'> {
    dFormControl?: DFormControl;
    dModel?: V[];
    dList: DCheckboxList<V>[];
    dDisabled?: boolean;
    dVertical?: boolean;
    onModelChange?: (values: V[]) => void;
}
export declare function DCheckboxGroup<V extends DId>(props: DCheckboxGroupProps<V>): JSX.Element | null;
