import type { DSize } from '../../utils';
import type { DFormControl } from '../form';
import type { Dayjs } from 'dayjs';
import React from 'react';
export interface DBuilderRef {
    updatePosition: () => void;
}
export interface DBuilderRenderProps {
    pbDate: Date | null;
    pbCurrentDate: [Date | null, Date | null];
    pbPosition: 'start' | 'end';
    changeValue: (date: Date | [Date, Date]) => void;
}
export interface DBuilderProps extends Omit<React.HTMLAttributes<HTMLDivElement>, 'children'> {
    children: (props: DBuilderRenderProps) => React.ReactNode;
    dClassNamePrefix: string;
    dFormControl?: DFormControl;
    dModel?: Date | null | [Date, Date];
    dFormat: string;
    dVisible?: boolean;
    dSuffix?: React.ReactNode;
    dPlaceholder: [string, string];
    dOrder: (date: [Dayjs | Date, Dayjs | Date]) => boolean;
    dPlacement?: 'top' | 'top-left' | 'top-right' | 'bottom' | 'bottom-left' | 'bottom-right';
    dSize?: DSize;
    dClearable?: boolean;
    dRange?: boolean;
    dDisabled?: boolean;
    dPopupClassName?: string;
    dInputProps?: React.InputHTMLAttributes<HTMLInputElement> | [React.InputHTMLAttributes<HTMLInputElement>?, React.InputHTMLAttributes<HTMLInputElement>?];
    dInputRef?: React.Ref<HTMLInputElement> | [React.Ref<HTMLInputElement>?, React.Ref<HTMLInputElement>?];
    onModelChange?: (date: any) => void;
    onVisibleChange?: (visible: boolean) => void;
    afterVisibleChange?: (visible: boolean) => void;
    onClear?: () => void;
    onUpdatePanel?: (date: Date) => void;
}
export declare const DBuilder: React.ForwardRefExoticComponent<DBuilderProps & React.RefAttributes<DBuilderRef>>;
