import type { DTimePickerProps } from '../time-picker';
import type { DBuilderProps } from './Builder';
import React from 'react';
export interface DDatePickerRef {
    updatePosition: () => void;
}
export interface DDatePickerProps extends Omit<DBuilderProps, 'dFormat' | 'dSuffix' | 'dPlaceholder' | 'dOrder' | 'onUpdatePanel'> {
    dFormat?: string;
    dPlaceholder?: string | [string?, string?];
    dOrder?: 'ascend' | 'descend' | null;
    dPresetDate?: Record<string, () => Date | [Date, Date]>;
    dConfigDate?: (date: Date, position: 'start' | 'end', current: [Date | null, Date | null]) => {
        disabled?: boolean;
    };
    dShowTime?: boolean | Pick<DTimePickerProps, 'd12Hour' | 'dConfigTime'>;
}
export declare const DDatePicker: React.ForwardRefExoticComponent<DDatePickerProps & React.RefAttributes<DDatePickerRef>>;
