var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { isUndefined, nth } from 'lodash';
import React, { useId, useImperativeHandle, useRef, useState } from 'react';
import { useEventCallback, useEventNotify, useIsomorphicLayoutEffect } from '@react-devui/hooks';
import { getClassName, getOriginalSize, getVerticalSidePosition, scrollToView } from '@react-devui/utils';
import { usePrefixConfig, useComponentConfig, useTranslation, useMaxIndex, useDValue } from '../../hooks';
import { registerComponentMate, TTANSITION_DURING_POPUP } from '../../utils';
import { DFocusVisible } from '../_focus-visible';
import { DPopup, useNestedPopup } from '../_popup';
import { DTransition } from '../_transition';
import { DGroup } from './Group';
import { DItem } from './Item';
import { DSub } from './Sub';
import { checkEnableItem, getSameLevelItems } from './utils';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DDropdown' });
function Dropdown(props, ref) {
    var _a, _b;
    const _c = useComponentConfig(COMPONENT_NAME, props), { children, dList, dVisible, dPlacement = 'bottom-right', dTrigger = 'hover', dArrow = false, dCloseOnClick = true, dZIndex, onVisibleChange, afterVisibleChange, onItemClick } = _c, restProps = __rest(_c, ["children", "dList", "dVisible", "dPlacement", "dTrigger", "dArrow", "dCloseOnClick", "dZIndex", "onVisibleChange", "afterVisibleChange", "onItemClick"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    //#region Ref
    const dropdownRef = useRef(null);
    const ulRef = useRef(null);
    //#endregion
    const [t] = useTranslation();
    const updatePosition$ = useEventNotify();
    const uniqueId = useId();
    const id = (_a = restProps.id) !== null && _a !== void 0 ? _a : `${dPrefix}dropdown-${uniqueId}`;
    const buttonId = (_b = children.props.id) !== null && _b !== void 0 ? _b : `${dPrefix}dropdown-button-${uniqueId}`;
    const getItemId = (id) => `${dPrefix}dropdown-item-${id}-${uniqueId}`;
    const { popupIds, setPopupIds, addPopupId, removePopupId } = useNestedPopup();
    const [focusIds, setFocusIds] = useState([]);
    const [isFocus, setIsFocus] = useState(false);
    const [focusVisible, setFocusVisible] = useState(false);
    const focusId = (() => {
        var _a;
        if (isFocus) {
            let id;
            for (const [index, focusId] of focusIds.entries()) {
                id = focusId;
                if (((_a = nth(popupIds, index)) === null || _a === void 0 ? void 0 : _a.id) !== focusId) {
                    break;
                }
            }
            return id;
        }
    })();
    const focusFirst = () => {
        const ids = [];
        const reduceArr = (arr) => {
            for (const item of arr) {
                if (ids.length === 1) {
                    break;
                }
                if (item.type === 'group' && item.children) {
                    reduceArr(item.children);
                }
                else if (checkEnableItem(item)) {
                    ids.push(item.id);
                }
            }
        };
        reduceArr(dList);
        setFocusIds(ids);
    };
    const focusLast = () => {
        const ids = [];
        const reduceArr = (arr) => {
            for (let index = arr.length - 1; index >= 0; index--) {
                if (ids.length === 1) {
                    break;
                }
                const item = arr[index];
                if (item.type === 'group' && item.children) {
                    reduceArr(item.children);
                }
                else if (checkEnableItem(item)) {
                    ids.push(item.id);
                }
            }
        };
        reduceArr(dList);
        setFocusIds(ids);
    };
    const [visible, changeVisible] = useDValue(false, dVisible, onVisibleChange);
    useIsomorphicLayoutEffect(() => {
        if (!visible) {
            setPopupIds([]);
        }
    }, [setPopupIds, visible]);
    const maxZIndex = useMaxIndex(visible);
    const zIndex = (() => {
        if (isUndefined(dZIndex)) {
            return maxZIndex;
        }
        else {
            return dZIndex;
        }
    })();
    const [popupPositionStyle, setPopupPositionStyle] = useState({
        top: -9999,
        left: -9999,
    });
    const [transformOrigin, setTransformOrigin] = useState();
    const [arrowPosition, setArrowPosition] = useState();
    const updatePosition = useEventCallback(() => {
        const triggerEl = document.getElementById(buttonId);
        if (triggerEl && dropdownRef.current) {
            const { width, height } = getOriginalSize(dropdownRef.current);
            const { top, left, transformOrigin, arrowPosition } = getVerticalSidePosition(triggerEl, { width, height }, dPlacement, 8);
            setPopupPositionStyle({ top, left });
            setTransformOrigin(transformOrigin);
            setArrowPosition(arrowPosition);
        }
    });
    const preventBlur = (e) => {
        if (e.button === 0) {
            e.preventDefault();
        }
    };
    let handleKeyDown;
    const nodes = (() => {
        const getNodes = (arr, level, subParents) => arr.map((item) => {
            var _a;
            const { id: itemId, label: itemLabel, type: itemType, icon: itemIcon, disabled: itemDisabled, children } = item;
            const newSubParents = itemType === 'sub' ? subParents.concat([item]) : subParents;
            const id = getItemId(itemId);
            const isFocus = itemId === focusId;
            const isEmpty = !(children && children.length > 0);
            const popupState = popupIds.find((v) => v.id === itemId);
            const handleItemClick = () => {
                onItemClick === null || onItemClick === void 0 ? void 0 : onItemClick(itemId, item);
                setFocusIds(subParents.map((parentItem) => parentItem.id).concat([itemId]));
                if (dCloseOnClick) {
                    changeVisible(false);
                }
            };
            if (isFocus) {
                handleKeyDown = (e) => {
                    var _a, _b, _c, _d;
                    const sameLevelItems = getSameLevelItems((_b = (_a = nth(subParents, -1)) === null || _a === void 0 ? void 0 : _a.children) !== null && _b !== void 0 ? _b : dList);
                    const focusItem = (val) => {
                        if (val) {
                            setFocusIds(subParents.map((parentItem) => parentItem.id).concat([val.id]));
                        }
                    };
                    const scrollToItem = (val) => {
                        if (val) {
                            const el = document.getElementById(getItemId(val.id));
                            if (el && ulRef.current) {
                                scrollToView(el, ulRef.current, 4);
                            }
                        }
                    };
                    switch (e.code) {
                        case 'ArrowUp': {
                            e.preventDefault();
                            const index = sameLevelItems.findIndex((sameLevelItem) => sameLevelItem.id === itemId);
                            const item = nth(sameLevelItems, index - 1);
                            focusItem(item);
                            scrollToItem(item);
                            if (item && ((_c = nth(popupIds, -1)) === null || _c === void 0 ? void 0 : _c.id) === itemId) {
                                setPopupIds(popupIds.slice(0, -1));
                            }
                            break;
                        }
                        case 'ArrowDown': {
                            e.preventDefault();
                            const index = sameLevelItems.findIndex((sameLevelItem) => sameLevelItem.id === itemId);
                            const item = nth(sameLevelItems, (index + 1) % sameLevelItems.length);
                            focusItem(item);
                            scrollToItem(item);
                            if (item && ((_d = nth(popupIds, -1)) === null || _d === void 0 ? void 0 : _d.id) === itemId) {
                                setPopupIds(popupIds.slice(0, -1));
                            }
                            break;
                        }
                        case 'ArrowLeft': {
                            e.preventDefault();
                            setPopupIds(popupIds.slice(0, -1));
                            const ids = subParents.map((item) => item.id);
                            if (ids.length > 0) {
                                setFocusIds(ids);
                            }
                            break;
                        }
                        case 'ArrowRight':
                            e.preventDefault();
                            if (itemType === 'sub') {
                                addPopupId(itemId);
                                if (children) {
                                    const newFocusItem = nth(getSameLevelItems(children), 0);
                                    if (newFocusItem) {
                                        setFocusIds(newSubParents.map((parentItem) => parentItem.id).concat([newFocusItem.id]));
                                    }
                                }
                            }
                            break;
                        case 'Home':
                            e.preventDefault();
                            focusItem(nth(sameLevelItems, 0));
                            if (ulRef.current) {
                                ulRef.current.scrollTop = 0;
                            }
                            break;
                        case 'End':
                            e.preventDefault();
                            focusItem(nth(sameLevelItems, -1));
                            if (ulRef.current) {
                                ulRef.current.scrollTop = ulRef.current.scrollHeight;
                            }
                            break;
                        case 'Enter':
                        case 'Space':
                            e.preventDefault();
                            if (itemType === 'item') {
                                handleItemClick();
                            }
                            else if (itemType === 'sub') {
                                addPopupId(itemId);
                            }
                            break;
                        default:
                            break;
                    }
                };
            }
            return (_jsx(React.Fragment, { children: itemType === 'item' ? (_jsx(DItem, Object.assign({ dId: id, dDisabled: itemDisabled, dFocusVisible: focusVisible && isFocus, dIcon: itemIcon, dLevel: level, onItemClick: handleItemClick }, { children: itemLabel }))) : itemType === 'group' ? (_jsx(DGroup, Object.assign({ dId: id, dList: children && getNodes(children, level + 1, newSubParents), dEmpty: isEmpty, dLevel: level }, { children: itemLabel }))) : (_jsx(DSub, Object.assign({ dId: id, dDisabled: itemDisabled, dFocusVisible: focusVisible && isFocus, dPopup: children && getNodes(children, 0, newSubParents), dPopupVisible: !isUndefined(popupState), dPopupState: (_a = popupState === null || popupState === void 0 ? void 0 : popupState.visible) !== null && _a !== void 0 ? _a : false, dEmpty: isEmpty, dTrigger: dTrigger, dIcon: itemIcon, dLevel: level, onVisibleChange: (visible) => {
                        if (visible) {
                            if (subParents.length === 0) {
                                setPopupIds([{ id: itemId, visible: true }]);
                            }
                            else {
                                addPopupId(itemId);
                            }
                        }
                        else {
                            removePopupId(itemId);
                        }
                    }, "updatePosition$": updatePosition$ }, { children: itemLabel }))) }, itemId));
        });
        return getNodes(dList, 0, []);
    })();
    useImperativeHandle(ref, () => ({
        updatePosition: () => {
            updatePosition();
            updatePosition$.next();
        },
    }), [updatePosition, updatePosition$]);
    return (_jsx(DTransition, Object.assign({ dIn: visible, dDuring: TTANSITION_DURING_POPUP, onEnterRendered: updatePosition, afterEnter: () => {
            afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(true);
        }, afterLeave: () => {
            afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(false);
        } }, { children: (state) => {
            let transitionStyle = {};
            switch (state) {
                case 'enter':
                    transitionStyle = { transform: 'scaleY(0.7)', opacity: 0 };
                    break;
                case 'entering':
                    transitionStyle = {
                        transition: ['transform', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING_POPUP}ms ease-out`).join(', '),
                        transformOrigin,
                    };
                    break;
                case 'leaving':
                    transitionStyle = {
                        transform: 'scaleY(0.7)',
                        opacity: 0,
                        transition: ['transform', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING_POPUP}ms ease-in`).join(', '),
                        transformOrigin,
                    };
                    break;
                case 'leaved':
                    transitionStyle = { display: 'none' };
                    break;
                default:
                    break;
            }
            return (_jsx(DPopup, Object.assign({ dPopup: (_a) => {
                    var { pOnClick, pOnMouseEnter, pOnMouseLeave } = _a, restPProps = __rest(_a, ["pOnClick", "pOnMouseEnter", "pOnMouseLeave"]);
                    return (_jsxs("div", Object.assign({ ref: dropdownRef }, restProps, restPProps, { className: getClassName(restProps.className, `${dPrefix}dropdown`), style: Object.assign(Object.assign(Object.assign(Object.assign({}, restProps.style), popupPositionStyle), transitionStyle), { zIndex }), onClick: (e) => {
                            var _a;
                            (_a = restProps.onClick) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                            pOnClick === null || pOnClick === void 0 ? void 0 : pOnClick(e);
                        }, onMouseEnter: (e) => {
                            var _a;
                            (_a = restProps.onMouseEnter) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                            pOnMouseEnter === null || pOnMouseEnter === void 0 ? void 0 : pOnMouseEnter(e);
                        }, onMouseLeave: (e) => {
                            var _a;
                            (_a = restProps.onMouseLeave) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                            pOnMouseLeave === null || pOnMouseLeave === void 0 ? void 0 : pOnMouseLeave(e);
                        }, onMouseDown: (e) => {
                            var _a;
                            (_a = restProps.onMouseDown) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                            preventBlur(e);
                        }, onMouseUp: (e) => {
                            var _a;
                            (_a = restProps.onMouseUp) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                            preventBlur(e);
                        } }, { children: [_jsx("ul", Object.assign({ ref: ulRef, id: id, className: `${dPrefix}dropdown__list`, tabIndex: -1, role: "menu", "aria-labelledby": buttonId, "aria-activedescendant": isUndefined(focusId) ? undefined : getItemId(focusId) }, { children: dList.length === 0 ? _jsx("div", Object.assign({ className: `${dPrefix}dropdown__empty` }, { children: t('No Data') })) : nodes })), dArrow && _jsx("div", { className: `${dPrefix}dropdown__arrow`, style: arrowPosition })] })));
                }, dVisible: visible, dTrigger: dTrigger, dUpdatePosition: updatePosition, onVisibleChange: changeVisible }, { children: (_a) => {
                    var { pOnClick, pOnMouseEnter, pOnMouseLeave } = _a, restPProps = __rest(_a, ["pOnClick", "pOnMouseEnter", "pOnMouseLeave"]);
                    return (_jsx(DFocusVisible, Object.assign({ onFocusVisibleChange: setFocusVisible }, { children: ({ fvOnFocus, fvOnBlur, fvOnKeyDown }) => {
                            var _a, _b, _c, _d, _e;
                            return React.cloneElement(children, Object.assign(Object.assign(Object.assign({}, children.props), restPProps), { id: (_a = children.props.id) !== null && _a !== void 0 ? _a : buttonId, role: (_b = children.props.role) !== null && _b !== void 0 ? _b : 'button', 'aria-haspopup': (_c = children.props['aria-haspopup']) !== null && _c !== void 0 ? _c : 'menu', 'aria-expanded': (_d = children.props['aria-expanded']) !== null && _d !== void 0 ? _d : visible, 'aria-controls': (_e = children.props['aria-controls']) !== null && _e !== void 0 ? _e : id, onClick: (e) => {
                                    var _a, _b;
                                    (_b = (_a = children.props).onClick) === null || _b === void 0 ? void 0 : _b.call(_a, e);
                                    pOnClick === null || pOnClick === void 0 ? void 0 : pOnClick(e);
                                }, onFocus: (e) => {
                                    var _a, _b;
                                    (_b = (_a = children.props).onFocus) === null || _b === void 0 ? void 0 : _b.call(_a, e);
                                    fvOnFocus(e);
                                    setIsFocus(true);
                                    focusFirst();
                                }, onBlur: (e) => {
                                    var _a, _b;
                                    (_b = (_a = children.props).onBlur) === null || _b === void 0 ? void 0 : _b.call(_a, e);
                                    fvOnBlur(e);
                                    setIsFocus(false);
                                    changeVisible(false);
                                }, onKeyDown: (e) => {
                                    var _a, _b;
                                    (_b = (_a = children.props).onKeyDown) === null || _b === void 0 ? void 0 : _b.call(_a, e);
                                    fvOnKeyDown(e);
                                    if (visible) {
                                        handleKeyDown === null || handleKeyDown === void 0 ? void 0 : handleKeyDown(e);
                                    }
                                    else {
                                        switch (e.code) {
                                            case 'Enter':
                                            case 'Space':
                                            case 'ArrowDown':
                                                e.preventDefault();
                                                focusFirst();
                                                changeVisible(true);
                                                break;
                                            case 'ArrowUp':
                                                e.preventDefault();
                                                focusLast();
                                                changeVisible(true);
                                                break;
                                            default:
                                                break;
                                        }
                                    }
                                }, onMouseEnter: (e) => {
                                    var _a, _b;
                                    (_b = (_a = children.props).onMouseEnter) === null || _b === void 0 ? void 0 : _b.call(_a, e);
                                    pOnMouseEnter === null || pOnMouseEnter === void 0 ? void 0 : pOnMouseEnter(e);
                                }, onMouseLeave: (e) => {
                                    var _a, _b;
                                    (_b = (_a = children.props).onMouseLeave) === null || _b === void 0 ? void 0 : _b.call(_a, e);
                                    pOnMouseLeave === null || pOnMouseLeave === void 0 ? void 0 : pOnMouseLeave(e);
                                } }));
                        } })));
                } })));
        } })));
}
export const DDropdown = React.forwardRef(Dropdown);
//# sourceMappingURL=Dropdown.js.map