import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { isUndefined } from 'lodash';
import { useId, useState } from 'react';
import { getClassName } from '@react-devui/utils';
import { usePrefixConfig } from '../../hooks';
import { DBaseInput } from '../_base-input';
import { DTooltip } from '../tooltip';
export function DStar(props) {
    var _a, _b;
    const { dFormControl, dValue, dName, dDisabled, dIcon, dChecked, dHoverValue, dHalf, dTooltip, onCheck, onHoverChange } = props;
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    const uniqueId = useId();
    const inputId = `${dPrefix}rating-star-input-${uniqueId}`;
    const halfInputId = `${dPrefix}rating-star-half-input-${uniqueId}`;
    const checked = dValue === dChecked;
    const halfValue = dValue - 0.5;
    const halfChecked = halfValue === dChecked;
    const [tooltipValue, setTooltipValue] = useState(dValue);
    const [isFocus, setIsFocus] = useState(false);
    return (_jsx(DTooltip, Object.assign({ dDisabled: isUndefined(dTooltip), dTitle: dTooltip === null || dTooltip === void 0 ? void 0 : dTooltip(tooltipValue) }, { children: _jsxs("div", Object.assign({ className: getClassName(`${dPrefix}rating__star`, {
                'is-focus': isFocus,
            }) }, { children: [dHalf && (_jsxs(_Fragment, { children: [_jsx(DBaseInput, { id: halfInputId, className: getClassName(`${dPrefix}rating__input`, `${dPrefix}rating__input--half`), type: "radio", name: dName, checked: halfChecked, disabled: dDisabled, "aria-checked": halfChecked, onChange: () => {
                                onCheck(halfValue);
                            }, onFocus: () => {
                                setIsFocus(true);
                            }, onBlur: () => {
                                setIsFocus(false);
                            }, onMouseEnter: () => {
                                if (!isUndefined(dTooltip)) {
                                    setTooltipValue(halfValue);
                                }
                                onHoverChange(halfValue);
                            }, dFormControl: dFormControl, dFor: halfChecked }), _jsx("label", Object.assign({ className: getClassName(`${dPrefix}rating__icon`, `${dPrefix}rating__icon--half`, {
                                'is-checked': halfValue <= ((_a = dHoverValue !== null && dHoverValue !== void 0 ? dHoverValue : dChecked) !== null && _a !== void 0 ? _a : 0),
                            }), htmlFor: halfInputId }, { children: dIcon }))] })), _jsxs("label", Object.assign({ className: getClassName(`${dPrefix}rating__icon`, {
                        'is-checked': dValue <= ((_b = dHoverValue !== null && dHoverValue !== void 0 ? dHoverValue : dChecked) !== null && _b !== void 0 ? _b : 0),
                    }) }, { children: [_jsx(DBaseInput, { id: inputId, className: `${dPrefix}rating__input`, type: "radio", name: dName, checked: checked, disabled: dDisabled, "aria-checked": checked, onChange: () => {
                                onCheck(dValue);
                            }, onFocus: () => {
                                setIsFocus(true);
                            }, onBlur: () => {
                                setIsFocus(false);
                            }, onMouseEnter: () => {
                                if (!isUndefined(dTooltip)) {
                                    setTooltipValue(dValue);
                                }
                                onHoverChange(dValue);
                            }, dFormControl: dFormControl, dFor: checked }), dIcon] }))] })) })));
}
//# sourceMappingURL=Star.js.map