import type { DBuilderProps } from '../date-picker/Builder';
import React from 'react';
export interface DTimePickerRef {
    updatePosition: () => void;
}
export interface DTimePickerProps extends Omit<DBuilderProps, 'dFormat' | 'dSuffix' | 'dPlaceholder' | 'dOrder' | 'onUpdatePanel'> {
    dFormat?: string;
    dPlaceholder?: string | [string?, string?];
    dOrder?: 'ascend' | 'descend' | null;
    d12Hour?: boolean;
    dConfigTime?: (unit: 'hour' | 'minute' | 'second', value: number, position: 'start' | 'end', current: [Date | null, Date | null]) => {
        disabled?: boolean;
        hidden?: boolean;
    };
}
export declare const DTimePicker: React.ForwardRefExoticComponent<DTimePickerProps & React.RefAttributes<DTimePickerRef>>;
