import type { DElementSelector } from '@react-devui/hooks/useElement';
import type { DPopupPlacement } from '@react-devui/utils/position';
import React from 'react';
export interface DTooltipRef {
    updatePosition: () => void;
}
export interface DTooltipProps extends Omit<React.HTMLAttributes<HTMLDivElement>, 'children'> {
    children: React.ReactElement;
    dVisible?: boolean;
    dTrigger?: 'hover' | 'click';
    dTitle: React.ReactNode;
    dContainer?: DElementSelector | false;
    dPlacement?: DPopupPlacement;
    dEscClosable?: boolean;
    dArrow?: boolean;
    dDisabled?: boolean;
    dDistance?: number;
    dMouseEnterDelay?: number;
    dMouseLeaveDelay?: number;
    dZIndex?: number | string;
    onVisibleChange?: (visible: boolean) => void;
    afterVisibleChange?: (visible: boolean) => void;
}
export declare const DTooltip: React.ForwardRefExoticComponent<DTooltipProps & React.RefAttributes<DTooltipRef>>;
