import type { DId } from '../../utils';
import type { DFormControl } from '../form';
import React from 'react';
export declare const IS_SELECTED: unique symbol;
export interface DTransferItem<V extends DId> {
    label: string;
    value: V;
    disabled?: boolean;
}
export interface DTransferProps<V extends DId, T extends DTransferItem<V>> extends Omit<React.HTMLAttributes<HTMLDivElement>, 'children'> {
    dFormControl?: DFormControl;
    dList: T[];
    dModel?: V[];
    dSelected?: V[];
    dTitle?: [React.ReactNode?, React.ReactNode?];
    dActions?: React.ReactNode[];
    dLoading?: [boolean?, boolean?];
    dSearchable?: boolean;
    dDisabled?: boolean;
    dCustomItem?: (item: T) => React.ReactNode;
    dCustomSearch?: {
        filter?: (value: string, item: T) => boolean;
        sort?: (a: T, b: T) => number;
    };
    onModelChange?: (value: V[], item: T[]) => void;
    onSelectedChange?: (value: V[], item: T[]) => void;
    onSearch?: (value: string, direction: 'left' | 'right') => void;
    onScrollBottom?: (direction: 'left' | 'right') => void;
}
export declare function DTransfer<V extends DId, T extends DTransferItem<V>>(props: DTransferProps<V, T>): JSX.Element | null;
