import type { DId } from '../../utils';
import React from 'react';
export declare type DVirtualScrollPerformance<T> = Pick<DVirtualScrollProps<T>, 'dList' | 'dExpands' | 'dItemSize' | 'dItemNested' | 'dItemKey' | 'dFocusable'>;
export interface DVirtualScrollRef<T> {
    scrollToItem: (item: T) => void;
    scrollByStep: (step: number) => T | undefined;
    scrollToStart: () => T | undefined;
    scrollToEnd: () => T | undefined;
}
export interface DItemRenderProps {
    iARIA: {
        'aria-level': number;
        'aria-setsize': number;
        'aria-posinset': number;
    };
    iChildren?: React.ReactNode[];
}
export interface DVirtualScrollRenderProps {
    vsScrollRef: React.RefCallback<any>;
    vsRender: React.ReactNode;
    vsOnScroll: React.UIEventHandler;
}
export interface DVirtualScrollProps<T> {
    children: (props: DVirtualScrollRenderProps) => JSX.Element | null;
    dList: T[];
    dFillNode: React.ReactElement;
    dItemRender: (item: T, index: number, props: DItemRenderProps, parent: T[]) => React.ReactNode;
    dItemSize: number | ((item: T) => number);
    dItemNested?: (item: T) => {
        list?: T[];
        emptySize?: number;
        asItem: boolean;
    } | undefined;
    dItemKey: (item: T) => DId;
    dFocusable?: boolean | ((item: T) => boolean);
    dFocusItem?: T;
    dSize?: number;
    dPadding?: number;
    dHorizontal?: boolean;
    dEmptyRender?: (item: T) => React.ReactNode;
    dExpands?: Set<DId>;
    onScrollEnd?: () => void;
}
declare function VirtualScroll<T>(props: DVirtualScrollProps<T>, ref: React.ForwardedRef<DVirtualScrollRef<T>>): JSX.Element | null;
export declare const DVirtualScroll: <T>(props: DVirtualScrollProps<T> & React.RefAttributes<DVirtualScrollRef<T>>) => ReturnType<typeof VirtualScroll>;
export {};
