import { useCallback, useContext } from 'react';
import { DConfigContext } from '../d-config/contex';
import resources from './resources.json';
export function useTranslation() {
    var _a, _b;
    const { lang = 'zh-Hant', resources: customResources } = (_b = (_a = useContext(DConfigContext)) === null || _a === void 0 ? void 0 : _a.i18n) !== null && _b !== void 0 ? _b : {};
    const t = useCallback((...keys) => {
        var _a;
        if (keys.length === 1) {
            keys = ['Common', keys[0]];
        }
        let content;
        if (customResources) {
            content = customResources;
            for (const key of keys) {
                content = content === null || content === void 0 ? void 0 : content[key];
            }
        }
        if (!content) {
            content = resources;
            for (const key of keys) {
                content = content === null || content === void 0 ? void 0 : content[key];
            }
        }
        return (_a = content === null || content === void 0 ? void 0 : content[lang]) !== null && _a !== void 0 ? _a : keys.join('.');
    }, [customResources, lang]);
    return [t, lang];
}
//# sourceMappingURL=useTranslation.js.map